/* rbpitch-plugin.c generated by valac 0.11.5, the Vala compiler
 * generated from rbpitch-plugin.vala, do not modify */

/* Copyright (C) Sean McNamara 2009-2010
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The Rhythmbox authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Rhythmbox. This permission is above and beyond the permissions granted
 * by the GPL license by which Rhythmbox is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <shell/rb-plugin.h>
#include <shell/rb-shell.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gconf/gconf-client.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <shell/rb-shell-player.h>
#include <backends/rb-player-gst-filter.h>
#include <backends/rb-player.h>
#include <gconf/gconf.h>


#define TYPE_RB_PITCH_PLUGIN (rb_pitch_plugin_get_type ())
#define RB_PITCH_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RB_PITCH_PLUGIN, RBPitchPlugin))
#define RB_PITCH_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RB_PITCH_PLUGIN, RBPitchPluginClass))
#define IS_RB_PITCH_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RB_PITCH_PLUGIN))
#define IS_RB_PITCH_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RB_PITCH_PLUGIN))
#define RB_PITCH_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RB_PITCH_PLUGIN, RBPitchPluginClass))

typedef struct _RBPitchPlugin RBPitchPlugin;
typedef struct _RBPitchPluginClass RBPitchPluginClass;
typedef struct _RBPitchPluginPrivate RBPitchPluginPrivate;

#define RB_PITCH_PLUGIN_TYPE_BOUND_TYPE (rb_pitch_plugin_bound_type_get_type ())
#define _gst_object_unref0(var) ((var == NULL) ? NULL : (var = (gst_object_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))

struct _RBPitchPlugin {
	RBPlugin parent_instance;
	RBPitchPluginPrivate * priv;
};

struct _RBPitchPluginClass {
	RBPluginClass parent_class;
};

struct _RBPitchPluginPrivate {
	RBShell* sh;
	GstElement* pitch_element;
	guint mergeid;
	gboolean persist;
	guint pitch_adj_timeout_id;
	guint speed_adj_timeout_id;
	guint tempo_adj_timeout_id;
	GtkToggleAction* pitch_action;
	GtkActionGroup* action_group;
	GtkImage* rbpitch_icon;
	GtkWindow* pitch_ui_parent;
	GtkBuilder* builder;
	gchar* uifile;
	gchar* iconfile;
	GtkAdjustment* pitch_adj;
	GtkAdjustment* speed_adj;
	GtkAdjustment* tempo_adj;
	GtkButton* reset_pitch;
	GtkButton* reset_tempo;
	GtkButton* reset_speed;
	GtkSpinButton* pitch_sb;
	GtkSpinButton* speed_sb;
	GtkSpinButton* tempo_sb;
	GtkWindow* config_ui_parent;
	GtkAdjustment* adj_config_tempo_lb;
	GtkAdjustment* adj_config_tempo_ub;
	GtkAdjustment* adj_config_speed_lb;
	GtkAdjustment* adj_config_speed_ub;
	GtkAdjustment* adj_config_pitch_lb;
	GtkAdjustment* adj_config_pitch_ub;
	GtkSpinButton* sb_config_pitch_lb;
	GtkSpinButton* sb_config_pitch_ub;
	GtkSpinButton* sb_config_speed_lb;
	GtkSpinButton* sb_config_speed_ub;
	GtkSpinButton* sb_config_tempo_lb;
	GtkSpinButton* sb_config_tempo_ub;
	GtkButton* button_config_close;
	GtkCheckButton* check_config_persist;
	GConfClient* gconf;
	gdouble _drate;
	gdouble _dtempo;
	gdouble _dpitch;
};

typedef enum  {
	RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_LB,
	RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_UB,
	RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_LB,
	RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_UB,
	RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_LB,
	RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_UB
} RBPitchPluginBoundType;


static gpointer rb_pitch_plugin_parent_class = NULL;
static gint rb_pitch_plugin_STACKUP_TIME;
static gint rb_pitch_plugin_STACKUP_TIME = 1;
static gdouble rb_pitch_plugin_LN_2;
static gdouble rb_pitch_plugin_LN_2 = 0.0;
static gdouble rb_pitch_plugin_CONST_S_X;
static gdouble rb_pitch_plugin_CONST_S_X = 0.0;
static gdouble rb_pitch_plugin_CONST_G_X;
static gdouble rb_pitch_plugin_CONST_G_X = 0.0;
static gchar* rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY;
static gchar* rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY = NULL;
static gchar* rb_pitch_plugin_GC_PITCH_CTRL_KEY;
static gchar* rb_pitch_plugin_GC_PITCH_CTRL_KEY = NULL;
static gchar* rb_pitch_plugin_GC_SPEED_CTRL_KEY;
static gchar* rb_pitch_plugin_GC_SPEED_CTRL_KEY = NULL;
static gchar* rb_pitch_plugin_GC_TEMPO_CTRL_KEY;
static gchar* rb_pitch_plugin_GC_TEMPO_CTRL_KEY = NULL;
static gchar* rb_pitch_plugin_GC_PITCH_UB_KEY;
static gchar* rb_pitch_plugin_GC_PITCH_UB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_PITCH_LB_KEY;
static gchar* rb_pitch_plugin_GC_PITCH_LB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_SPEED_UB_KEY;
static gchar* rb_pitch_plugin_GC_SPEED_UB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_SPEED_LB_KEY;
static gchar* rb_pitch_plugin_GC_SPEED_LB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_TEMPO_UB_KEY;
static gchar* rb_pitch_plugin_GC_TEMPO_UB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_TEMPO_LB_KEY;
static gchar* rb_pitch_plugin_GC_TEMPO_LB_KEY = NULL;
static gchar* rb_pitch_plugin_GC_RBPITCH_DIR;
static gchar* rb_pitch_plugin_GC_RBPITCH_DIR = NULL;
static gdouble rb_pitch_plugin_PITCH_LB_MIN;
static gdouble rb_pitch_plugin_PITCH_LB_MIN = 0.0;
static gdouble rb_pitch_plugin_PITCH_UB_MAX;
static gdouble rb_pitch_plugin_PITCH_UB_MAX = 0.0;
static gdouble rb_pitch_plugin_SPEED_LB_MIN;
static gdouble rb_pitch_plugin_SPEED_LB_MIN = 0.0;
static gdouble rb_pitch_plugin_SPEED_UB_MAX;
static gdouble rb_pitch_plugin_SPEED_UB_MAX = 900.0;
static gdouble rb_pitch_plugin_TEMPO_LB_MIN;
static gdouble rb_pitch_plugin_TEMPO_LB_MIN = 0.0;
static gdouble rb_pitch_plugin_TEMPO_UB_MAX;
static gdouble rb_pitch_plugin_TEMPO_UB_MAX = 900.0;
static gdouble rb_pitch_plugin_PITCH_RESET;
static gdouble rb_pitch_plugin_PITCH_RESET = 0.0;
static gdouble rb_pitch_plugin_SPEED_RESET;
static gdouble rb_pitch_plugin_SPEED_RESET = 0.0;
static gdouble rb_pitch_plugin_TEMPO_RESET;
static gdouble rb_pitch_plugin_TEMPO_RESET = 0.0;
static GRegex* rb_pitch_plugin_semitone_input_regex;
static GRegex* rb_pitch_plugin_semitone_input_regex = NULL;
static GRegex* rb_pitch_plugin_percent_input_regex;
static GRegex* rb_pitch_plugin_percent_input_regex = NULL;
static gboolean rb_pitch_plugin_inserted;
static gboolean rb_pitch_plugin_inserted = FALSE;
static GType rb_pitch_plugin_type_id = 0;

GType rb_pitch_plugin_get_type (void) G_GNUC_CONST;
GType rb_pitch_plugin_register_type (GTypeModule * module);
#define RB_PITCH_PLUGIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RB_PITCH_PLUGIN, RBPitchPluginPrivate))
enum  {
	RB_PITCH_PLUGIN_DUMMY_PROPERTY,
	RB_PITCH_PLUGIN_DRATE,
	RB_PITCH_PLUGIN_DPITCH,
	RB_PITCH_PLUGIN_DTEMPO
};
static GType rb_pitch_plugin_bound_type_get_type (void) G_GNUC_UNUSED;
static inline gdouble rb_pitch_plugin_xlate_pitch_to_semi (gdouble pitch_native);
#define RB_PITCH_PLUGIN_ui_addition "<ui> <toolbar name=\"ToolBar\"> <toolitem name=\"PitchButton\" action=" \
"\"PitchAction\"/> </toolbar> </ui>"
#define RB_PITCH_PLUGIN_ui_xml "rbpitch-layout.xml"
#define RB_PITCH_PLUGIN_iconpath "rbpitchicon.svg"
RBPitchPlugin* rb_pitch_plugin_new (void);
RBPitchPlugin* rb_pitch_plugin_construct (GType object_type);
static void rb_pitch_plugin_real_activate (RBPlugin* base, RBShell* shell);
static void rb_pitch_plugin_no_ui_file_error (RBPitchPlugin* self);
gboolean rb_pitch_plugin_have_gst_player (RBPitchPlugin* self);
static void rb_pitch_plugin_no_gst_error (RBPitchPlugin* self);
gboolean rb_pitch_plugin_pitch_init_check (RBPitchPlugin* self, gboolean force);
static void rb_pitch_plugin_pitch_not_found_error (RBPitchPlugin* self);
static void rb_pitch_plugin_insert_pitch_element (RBPitchPlugin* self);
static void _lambda0_ (GtkAction* t, RBPitchPlugin* self);
static void rb_pitch_plugin_display_ui (RBPitchPlugin* self);
static void rb_pitch_plugin_hide_ui (RBPitchPlugin* self);
static void __lambda0__gtk_action_activate (GtkAction* _sender, gpointer self);
gboolean rb_pitch_plugin_gconf_init (RBPitchPlugin* self);
static void rb_pitch_plugin_no_gconf_error (RBPitchPlugin* self);
static void rb_pitch_plugin_construct_config_ui (RBPitchPlugin* self);
static void rb_pitch_plugin_construct_ui (RBPitchPlugin* self);
static void rb_pitch_plugin_real_deactivate (RBPlugin* base, RBShell* shell);
static void rb_pitch_plugin_remove_pitch_element (RBPitchPlugin* self);
static void rb_pitch_plugin_destroy_ui (RBPitchPlugin* self);
static void rb_pitch_plugin_destroy_config_ui (RBPitchPlugin* self);
static gboolean _lambda2_ (GtkWidget* t, GdkEvent* a, RBPitchPlugin* self);
static void rb_pitch_plugin_hide_config_ui (RBPitchPlugin* self);
static gboolean __lambda2__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self);
static void _lambda3_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda3__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda4_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda4__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda5_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda6_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda7_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda7__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda8_ (GtkAdjustment* t, RBPitchPlugin* self);
static void __lambda8__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda9_ (GtkButton* t, RBPitchPlugin* self);
static void __lambda9__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _lambda10_ (GtkToggleButton* t, RBPitchPlugin* self);
static void __lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean rb_pitch_plugin_semitone_output_cb (GtkSpinButton* t);
static gboolean _rb_pitch_plugin_semitone_output_cb_gtk_spin_button_output (GtkSpinButton* _sender, gpointer self);
gboolean rb_pitch_plugin_percent_output_cb (GtkSpinButton* t);
static gboolean _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output (GtkSpinButton* _sender, gpointer self);
gint rb_pitch_plugin_semitone_input_cb (GtkSpinButton* t, void* new_value);
static gint _rb_pitch_plugin_semitone_input_cb_gtk_spin_button_input (GtkSpinButton* _sender, void* new_value, gpointer self);
gint rb_pitch_plugin_percent_input_cb (GtkSpinButton* t, void* new_value);
static gint _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input (GtkSpinButton* _sender, void* new_value, gpointer self);
static void rb_pitch_plugin_download_bounds (RBPitchPlugin* self);
static gboolean _lambda11_ (GtkWidget* t, GdkEvent* a, RBPitchPlugin* self);
static gboolean __lambda11__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self);
static void _lambda12_ (GtkAdjustment* t, RBPitchPlugin* self);
gboolean rb_pitch_plugin_pitch_adj_timeout_cb (RBPitchPlugin* self);
static gboolean _rb_pitch_plugin_pitch_adj_timeout_cb_gsource_func (gpointer self);
static void __lambda12__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda13_ (GtkAdjustment* t, RBPitchPlugin* self);
gboolean rb_pitch_plugin_speed_adj_timeout_cb (RBPitchPlugin* self);
static gboolean _rb_pitch_plugin_speed_adj_timeout_cb_gsource_func (gpointer self);
static void __lambda13__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda14_ (GtkAdjustment* t, RBPitchPlugin* self);
gboolean rb_pitch_plugin_tempo_adj_timeout_cb (RBPitchPlugin* self);
static gboolean _rb_pitch_plugin_tempo_adj_timeout_cb_gsource_func (gpointer self);
static void __lambda14__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void _lambda15_ (GtkButton* t, RBPitchPlugin* self);
static gboolean rb_pitch_plugin_clamp (gdouble* test, gdouble low, gdouble high);
static gdouble rb_pitch_plugin_get_pitch_lb (RBPitchPlugin* self);
static gdouble rb_pitch_plugin_get_pitch_ub (RBPitchPlugin* self);
static void __lambda15__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _lambda16_ (GtkButton* t, RBPitchPlugin* self);
static gdouble rb_pitch_plugin_get_speed_lb (RBPitchPlugin* self);
static gdouble rb_pitch_plugin_get_speed_ub (RBPitchPlugin* self);
static void __lambda16__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _lambda17_ (GtkButton* t, RBPitchPlugin* self);
static gdouble rb_pitch_plugin_get_tempo_lb (RBPitchPlugin* self);
static gdouble rb_pitch_plugin_get_tempo_ub (RBPitchPlugin* self);
static void __lambda17__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void rb_pitch_plugin_download_controls (RBPitchPlugin* self);
static inline gdouble rb_pitch_plugin_xlate_pitch_to_native (gdouble pitch_semi);
void rb_pitch_plugin_set_dpitch (RBPitchPlugin* self, gdouble value);
static inline gdouble rb_pitch_plugin_xlate_ts_to_native (gdouble ts_semi);
void rb_pitch_plugin_set_drate (RBPitchPlugin* self, gdouble value);
void rb_pitch_plugin_set_dtempo (RBPitchPlugin* self, gdouble value);
static gint rb_pitch_plugin_generic_input_cb (GtkSpinButton* t, void* new_value, GRegex* reg);
static RBPlayerGstFilter* rb_pitch_plugin_get_filter (RBPitchPlugin* self);
static RBPlayer* rb_pitch_plugin_get_player_backend (RBPitchPlugin* self);
gdouble rb_pitch_plugin_get_drate (RBPitchPlugin* self);
gdouble rb_pitch_plugin_get_dpitch (RBPitchPlugin* self);
gdouble rb_pitch_plugin_get_dtempo (RBPitchPlugin* self);
static void _lambda1_ (GConfClient* t, guint cnxn_id, GConfEntry* entry, RBPitchPlugin* self);
static gboolean rb_pitch_plugin_try_adjust_bound (RBPitchPlugin* self, gdouble val, RBPitchPluginBoundType bt);
static void __lambda1__gconf_client_notify_func (GConfClient* client, guint cnxn_id, GConfEntry* entry, gpointer self);
static gboolean rb_pitch_plugin_try_adjust_bound_priv (RBPitchPlugin* self, gdouble newval, gdouble oldlow, gdouble oldhigh, const gchar* config_key, const gchar* ctrl_key, GtkAdjustment* config_adj, GtkAdjustment* control_adj, gboolean isUpper);
static GtkWidget* rb_pitch_plugin_real_create_configure_dialog (RBPlugin* base);
static void rb_pitch_plugin_display_error (RBPitchPlugin* self, const gchar* msg);
static inline gdouble rb_pitch_plugin_xlate_ts_to_semi (gdouble ts_native);
static void rb_pitch_plugin_finalize (GObject* obj);
static void _vala_rb_pitch_plugin_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_rb_pitch_plugin_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_rb_plugin (GTypeModule* module);


static GType rb_pitch_plugin_bound_type_get_type (void) {
	static volatile gsize rb_pitch_plugin_bound_type_type_id__volatile = 0;
	if (g_once_init_enter (&rb_pitch_plugin_bound_type_type_id__volatile)) {
		static const GEnumValue values[] = {{RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_LB, "RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_LB", "pitch-lb"}, {RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_UB, "RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_UB", "pitch-ub"}, {RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_LB, "RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_LB", "speed-lb"}, {RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_UB, "RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_UB", "speed-ub"}, {RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_LB, "RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_LB", "tempo-lb"}, {RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_UB, "RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_UB", "tempo-ub"}, {0, NULL, NULL}};
		GType rb_pitch_plugin_bound_type_type_id;
		rb_pitch_plugin_bound_type_type_id = g_enum_register_static ("RBPitchPluginBoundType", values);
		g_once_init_leave (&rb_pitch_plugin_bound_type_type_id__volatile, rb_pitch_plugin_bound_type_type_id);
	}
	return rb_pitch_plugin_bound_type_type_id__volatile;
}


RBPitchPlugin* rb_pitch_plugin_construct (GType object_type) {
	RBPitchPlugin * self = NULL;
	self = (RBPitchPlugin*) g_object_new (object_type, NULL);
	return self;
}


RBPitchPlugin* rb_pitch_plugin_new (void) {
	return rb_pitch_plugin_construct (TYPE_RB_PITCH_PLUGIN);
}


static void _lambda0_ (GtkAction* t, RBPitchPlugin* self) {
	gboolean _tmp0_;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_toggle_action_get_active (GTK_TOGGLE_ACTION (t));
	if (_tmp0_) {
		rb_pitch_plugin_display_ui (self);
	} else {
		rb_pitch_plugin_hide_ui (self);
	}
}


static void __lambda0__gtk_action_activate (GtkAction* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void rb_pitch_plugin_real_activate (RBPlugin* base, RBShell* shell) {
	RBPitchPlugin * self;
	GRegex* _tmp0_ = NULL;
	GRegex* _tmp1_;
	GRegex* _tmp2_;
	GRegex* _tmp3_ = NULL;
	GRegex* _tmp4_;
	GRegex* _tmp5_;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	GtkImage* _tmp15_ = NULL;
	GtkImage* _tmp16_;
	GObject* _tmp17_ = NULL;
	GtkUIManager* uim;
	guint _tmp18_;
	guint _tmp19_;
	GtkBuilder* _tmp20_ = NULL;
	GtkBuilder* _tmp21_;
	gboolean _tmp22_;
	GtkWidget* _tmp23_ = NULL;
	GtkWidget* _tmp24_;
	GtkWidget* mwidge;
	GError * _inner_error_ = NULL;
	self = (RBPitchPlugin*) base;
	g_return_if_fail (shell != NULL);
	self->priv->sh = shell;
	_tmp0_ = g_regex_new ("(?P<whole>-?((\\d+\\.\\d+)|(\\.\\d+)|(\\d+)))\\s*(st|s\\.t\\.)?", G_REGEX_CASELESS | G_REGEX_OPTIMIZE, G_REGEX_MATCH_NOTEMPTY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp2_ = _tmp1_;
	_g_regex_unref0 (rb_pitch_plugin_semitone_input_regex);
	rb_pitch_plugin_semitone_input_regex = _tmp2_;
	_tmp3_ = g_regex_new ("(?P<whole>-?((\\d+\\.\\d+)|(\\.\\d+)|(\\d+)))\\s*%?", G_REGEX_CASELESS | G_REGEX_OPTIMIZE, G_REGEX_MATCH_NOTEMPTY, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp5_ = _tmp4_;
	_g_regex_unref0 (rb_pitch_plugin_percent_input_regex);
	rb_pitch_plugin_percent_input_regex = _tmp5_;
	_tmp6_ = rb_plugin_find_file ((RBPlugin*) self, RB_PITCH_PLUGIN_ui_xml);
	_tmp7_ = g_strdup (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (self->priv->uifile);
	self->priv->uifile = _tmp8_;
	_tmp9_ = rb_plugin_find_file ((RBPlugin*) self, RB_PITCH_PLUGIN_iconpath);
	_tmp10_ = g_strdup (_tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (self->priv->iconfile);
	self->priv->iconfile = _tmp11_;
	if (self->priv->uifile == NULL) {
		rb_pitch_plugin_no_ui_file_error (self);
		return;
	}
	_tmp12_ = rb_pitch_plugin_have_gst_player (self);
	if (!_tmp12_) {
		rb_pitch_plugin_no_gst_error (self);
		return;
	}
	if (shell == NULL) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp14_;
		_tmp14_ = rb_pitch_plugin_pitch_init_check (self, TRUE);
		_tmp13_ = !_tmp14_;
	}
	if (_tmp13_) {
		rb_pitch_plugin_pitch_not_found_error (self);
		return;
	}
	rb_pitch_plugin_insert_pitch_element (self);
	g_signal_connect_object ((GtkAction*) self->priv->pitch_action, "activate", (GCallback) __lambda0__gtk_action_activate, self, 0);
	_tmp15_ = (GtkImage*) gtk_image_new_from_file (self->priv->iconfile);
	_tmp16_ = g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->rbpitch_icon);
	self->priv->rbpitch_icon = _tmp16_;
	gtk_action_group_add_action (self->priv->action_group, (GtkAction*) self->priv->pitch_action);
	_tmp17_ = rb_shell_get_ui_manager (shell);
	uim = GTK_UI_MANAGER (_tmp17_);
	gtk_ui_manager_insert_action_group (uim, self->priv->action_group, 0);
	_tmp18_ = gtk_ui_manager_add_ui_from_string (uim, RB_PITCH_PLUGIN_ui_addition, (gssize) (-1), &_inner_error_);
	_tmp19_ = _tmp18_;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (uim);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->mergeid = _tmp19_;
	gtk_ui_manager_ensure_update (uim);
	_tmp20_ = gtk_builder_new ();
	_tmp21_ = _tmp20_;
	_g_object_unref0 (self->priv->builder);
	self->priv->builder = _tmp21_;
	gtk_builder_add_from_file (self->priv->builder, self->priv->uifile, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (uim);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp22_ = rb_pitch_plugin_gconf_init (self);
	if (!_tmp22_) {
		rb_pitch_plugin_no_gconf_error (self);
	}
	rb_pitch_plugin_construct_config_ui (self);
	rb_pitch_plugin_construct_ui (self);
	_tmp23_ = gtk_ui_manager_get_widget (uim, "/ui/ToolBar/PitchButton");
	_tmp24_ = _g_object_ref0 (_tmp23_);
	mwidge = _tmp24_;
	if (mwidge == NULL) {
		g_critical ("rbpitch-plugin.vala:278: Invalid widget path in uim.get_widget()\n");
	} else {
		gtk_tool_button_set_icon_widget ((GtkToolButton*) GTK_TOGGLE_TOOL_BUTTON (mwidge), (GtkWidget*) self->priv->rbpitch_icon);
		gtk_tool_button_set_label_widget ((GtkToolButton*) GTK_TOGGLE_TOOL_BUTTON (mwidge), (GtkWidget*) self->priv->rbpitch_icon);
		gtk_widget_show ((GtkWidget*) self->priv->rbpitch_icon);
	}
	_g_object_unref0 (mwidge);
	_g_object_unref0 (uim);
}


static void rb_pitch_plugin_real_deactivate (RBPlugin* base, RBShell* shell) {
	RBPitchPlugin * self;
	GObject* _tmp0_ = NULL;
	GtkUIManager* uim;
	gchar* _tmp1_;
	self = (RBPitchPlugin*) base;
	g_return_if_fail (shell != NULL);
	self->priv->sh = shell;
	rb_pitch_plugin_remove_pitch_element (self);
	rb_pitch_plugin_destroy_ui (self);
	rb_pitch_plugin_destroy_config_ui (self);
	_tmp0_ = rb_shell_get_ui_manager (shell);
	uim = GTK_UI_MANAGER (_tmp0_);
	gtk_ui_manager_remove_ui (uim, self->priv->mergeid);
	gtk_ui_manager_remove_action_group (uim, self->priv->action_group);
	gtk_action_group_remove_action (self->priv->action_group, (GtkAction*) self->priv->pitch_action);
	gtk_toggle_action_set_active (self->priv->pitch_action, FALSE);
	self->priv->sh = NULL;
	_tmp1_ = NULL;
	_g_free0 (self->priv->uifile);
	self->priv->uifile = _tmp1_;
	_g_object_unref0 (uim);
}


static gboolean _lambda2_ (GtkWidget* t, GdkEvent* a, RBPitchPlugin* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (t != NULL, FALSE);
	g_return_val_if_fail (a != NULL, FALSE);
	rb_pitch_plugin_hide_config_ui (self);
	result = TRUE;
	return result;
}


static gboolean __lambda2__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self) {
	gboolean result;
	result = _lambda2_ (_sender, event, self);
	return result;
}


static void _lambda3_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_UB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda3__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


static void _lambda4_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_LB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda4__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda4_ (_sender, self);
}


static void _lambda5_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_UB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda5_ (_sender, self);
}


static void _lambda6_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_LB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda6_ (_sender, self);
}


static void _lambda7_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_UB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda7__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda7_ (_sender, self);
}


static void _lambda8_ (GtkAdjustment* t, RBPitchPlugin* self) {
	gdouble _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_adjustment_get_value (t);
	gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_LB_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda8__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda8_ (_sender, self);
}


static void _lambda9_ (GtkButton* t, RBPitchPlugin* self) {
	g_return_if_fail (t != NULL);
	rb_pitch_plugin_hide_config_ui (self);
}


static void __lambda9__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda9_ (_sender, self);
}


static void _lambda10_ (GtkToggleButton* t, RBPitchPlugin* self) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->check_config_persist);
	gconf_client_set_bool (self->priv->gconf, rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY, _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void __lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda10_ (_sender, self);
}


static gboolean _rb_pitch_plugin_semitone_output_cb_gtk_spin_button_output (GtkSpinButton* _sender, gpointer self) {
	gboolean result;
	result = rb_pitch_plugin_semitone_output_cb (_sender);
	return result;
}


static gboolean _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output (GtkSpinButton* _sender, gpointer self) {
	gboolean result;
	result = rb_pitch_plugin_percent_output_cb (_sender);
	return result;
}


static gint _rb_pitch_plugin_semitone_input_cb_gtk_spin_button_input (GtkSpinButton* _sender, void* new_value, gpointer self) {
	gint result;
	result = rb_pitch_plugin_semitone_input_cb (_sender, new_value);
	return result;
}


static gint _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input (GtkSpinButton* _sender, void* new_value, gpointer self) {
	gint result;
	result = rb_pitch_plugin_percent_input_cb (_sender, new_value);
	return result;
}


static void rb_pitch_plugin_construct_config_ui (RBPitchPlugin* self) {
	GObject* _tmp2_ = NULL;
	GObject* _tmp3_ = NULL;
	GObject* _tmp4_ = NULL;
	GObject* _tmp5_ = NULL;
	GObject* _tmp6_ = NULL;
	GObject* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_ = NULL;
	GObject* _tmp10_ = NULL;
	GObject* _tmp11_ = NULL;
	GObject* _tmp12_ = NULL;
	GObject* _tmp13_ = NULL;
	GObject* _tmp14_ = NULL;
	GObject* _tmp15_ = NULL;
	GObject* _tmp16_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->builder == NULL) {
		GtkBuilder* _tmp0_ = NULL;
		GtkBuilder* _tmp1_;
		_tmp0_ = gtk_builder_new ();
		_tmp1_ = _tmp0_;
		_g_object_unref0 (self->priv->builder);
		self->priv->builder = _tmp1_;
		gtk_builder_add_from_file (self->priv->builder, self->priv->uifile, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp2_ = gtk_builder_get_object (self->priv->builder, "window-config");
	self->priv->config_ui_parent = GTK_WINDOW (_tmp2_);
	g_signal_connect_object ((GtkWidget*) self->priv->config_ui_parent, "delete-event", (GCallback) __lambda2__gtk_widget_delete_event, self, 0);
	_tmp3_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-pitch-ub");
	self->priv->adj_config_pitch_ub = GTK_ADJUSTMENT (_tmp3_);
	_tmp4_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-pitch-lb");
	self->priv->adj_config_pitch_lb = GTK_ADJUSTMENT (_tmp4_);
	_tmp5_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-speed-lb");
	self->priv->adj_config_speed_lb = GTK_ADJUSTMENT (_tmp5_);
	_tmp6_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-speed-ub");
	self->priv->adj_config_speed_ub = GTK_ADJUSTMENT (_tmp6_);
	_tmp7_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-tempo-lb");
	self->priv->adj_config_tempo_lb = GTK_ADJUSTMENT (_tmp7_);
	_tmp8_ = gtk_builder_get_object (self->priv->builder, "adjustment-config-tempo-ub");
	self->priv->adj_config_tempo_ub = GTK_ADJUSTMENT (_tmp8_);
	_tmp9_ = gtk_builder_get_object (self->priv->builder, "sb-config-pitch-ub");
	self->priv->sb_config_pitch_ub = GTK_SPIN_BUTTON (_tmp9_);
	_tmp10_ = gtk_builder_get_object (self->priv->builder, "sb-config-pitch-lb");
	self->priv->sb_config_pitch_lb = GTK_SPIN_BUTTON (_tmp10_);
	_tmp11_ = gtk_builder_get_object (self->priv->builder, "sb-config-speed-ub");
	self->priv->sb_config_speed_ub = GTK_SPIN_BUTTON (_tmp11_);
	_tmp12_ = gtk_builder_get_object (self->priv->builder, "sb-config-speed-lb");
	self->priv->sb_config_speed_lb = GTK_SPIN_BUTTON (_tmp12_);
	_tmp13_ = gtk_builder_get_object (self->priv->builder, "sb-config-tempo-ub");
	self->priv->sb_config_tempo_ub = GTK_SPIN_BUTTON (_tmp13_);
	_tmp14_ = gtk_builder_get_object (self->priv->builder, "sb-config-tempo-lb");
	self->priv->sb_config_tempo_lb = GTK_SPIN_BUTTON (_tmp14_);
	_tmp15_ = gtk_builder_get_object (self->priv->builder, "button-config-close");
	self->priv->button_config_close = GTK_BUTTON (_tmp15_);
	_tmp16_ = gtk_builder_get_object (self->priv->builder, "check-config-persist");
	self->priv->check_config_persist = GTK_CHECK_BUTTON (_tmp16_);
	g_signal_connect_object (self->priv->adj_config_pitch_ub, "value-changed", (GCallback) __lambda3__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->adj_config_pitch_lb, "value-changed", (GCallback) __lambda4__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->adj_config_speed_ub, "value-changed", (GCallback) __lambda5__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->adj_config_speed_lb, "value-changed", (GCallback) __lambda6__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->adj_config_tempo_ub, "value-changed", (GCallback) __lambda7__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->adj_config_tempo_lb, "value-changed", (GCallback) __lambda8__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->button_config_close, "clicked", (GCallback) __lambda9__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkToggleButton*) self->priv->check_config_persist, "toggled", (GCallback) __lambda10__gtk_toggle_button_toggled, self, 0);
	g_signal_connect (self->priv->sb_config_pitch_ub, "output", (GCallback) _rb_pitch_plugin_semitone_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_pitch_lb, "output", (GCallback) _rb_pitch_plugin_semitone_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_speed_ub, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_speed_lb, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_tempo_ub, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_tempo_lb, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->sb_config_pitch_ub, "input", (GCallback) _rb_pitch_plugin_semitone_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->sb_config_pitch_lb, "input", (GCallback) _rb_pitch_plugin_semitone_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->sb_config_speed_ub, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->sb_config_speed_lb, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->sb_config_tempo_ub, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->sb_config_tempo_lb, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	rb_pitch_plugin_download_bounds (self);
}


static void rb_pitch_plugin_download_bounds (RBPitchPlugin* self) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_UB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_pitch_ub, _tmp1_);
	_tmp2_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_LB_KEY, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_pitch_lb, _tmp3_);
	_tmp4_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_UB_KEY, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_speed_ub, _tmp5_);
	_tmp6_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_LB_KEY, &_inner_error_);
	_tmp7_ = _tmp6_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_speed_lb, _tmp7_);
	_tmp8_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_UB_KEY, &_inner_error_);
	_tmp9_ = _tmp8_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_tempo_ub, _tmp9_);
	_tmp10_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_LB_KEY, &_inner_error_);
	_tmp11_ = _tmp10_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_adjustment_set_value (self->priv->adj_config_tempo_lb, _tmp11_);
}


static gboolean _lambda11_ (GtkWidget* t, GdkEvent* a, RBPitchPlugin* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (t != NULL, FALSE);
	g_return_val_if_fail (a != NULL, FALSE);
	rb_pitch_plugin_hide_ui (self);
	gtk_toggle_action_set_active (self->priv->pitch_action, FALSE);
	result = TRUE;
	return result;
}


static gboolean __lambda11__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self) {
	gboolean result;
	result = _lambda11_ (_sender, event, self);
	return result;
}


static gboolean _rb_pitch_plugin_pitch_adj_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = rb_pitch_plugin_pitch_adj_timeout_cb (self);
	return result;
}


static void _lambda12_ (GtkAdjustment* t, RBPitchPlugin* self) {
	g_return_if_fail (t != NULL);
	if (self->priv->pitch_adj_timeout_id == 0) {
		guint _tmp0_;
		_tmp0_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) rb_pitch_plugin_STACKUP_TIME, _rb_pitch_plugin_pitch_adj_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->pitch_adj_timeout_id = _tmp0_;
	}
}


static void __lambda12__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda12_ (_sender, self);
}


static gboolean _rb_pitch_plugin_speed_adj_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = rb_pitch_plugin_speed_adj_timeout_cb (self);
	return result;
}


static void _lambda13_ (GtkAdjustment* t, RBPitchPlugin* self) {
	g_return_if_fail (t != NULL);
	if (self->priv->speed_adj_timeout_id == 0) {
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) rb_pitch_plugin_STACKUP_TIME, _rb_pitch_plugin_speed_adj_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	}
}


static void __lambda13__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda13_ (_sender, self);
}


static gboolean _rb_pitch_plugin_tempo_adj_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = rb_pitch_plugin_tempo_adj_timeout_cb (self);
	return result;
}


static void _lambda14_ (GtkAdjustment* t, RBPitchPlugin* self) {
	g_return_if_fail (t != NULL);
	if (self->priv->tempo_adj_timeout_id == 0) {
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) rb_pitch_plugin_STACKUP_TIME, _rb_pitch_plugin_tempo_adj_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	}
}


static void __lambda14__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda14_ (_sender, self);
}


static void _lambda15_ (GtkButton* t, RBPitchPlugin* self) {
	gdouble resetVal;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	resetVal = rb_pitch_plugin_PITCH_RESET;
	_tmp0_ = rb_pitch_plugin_get_pitch_lb (self);
	_tmp1_ = rb_pitch_plugin_get_pitch_ub (self);
	rb_pitch_plugin_clamp (&resetVal, _tmp0_, _tmp1_);
	gtk_adjustment_set_value (self->priv->pitch_adj, resetVal);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_CTRL_KEY, resetVal, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void __lambda15__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda15_ (_sender, self);
}


static void _lambda16_ (GtkButton* t, RBPitchPlugin* self) {
	gdouble resetVal;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	resetVal = rb_pitch_plugin_SPEED_RESET;
	_tmp0_ = rb_pitch_plugin_get_speed_lb (self);
	_tmp1_ = rb_pitch_plugin_get_speed_ub (self);
	rb_pitch_plugin_clamp (&resetVal, _tmp0_, _tmp1_);
	gtk_adjustment_set_value (self->priv->speed_adj, resetVal);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_CTRL_KEY, resetVal, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void __lambda16__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda16_ (_sender, self);
}


static void _lambda17_ (GtkButton* t, RBPitchPlugin* self) {
	gdouble resetVal;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (t != NULL);
	resetVal = rb_pitch_plugin_TEMPO_RESET;
	_tmp0_ = rb_pitch_plugin_get_tempo_lb (self);
	_tmp1_ = rb_pitch_plugin_get_tempo_ub (self);
	rb_pitch_plugin_clamp (&resetVal, _tmp0_, _tmp1_);
	gtk_adjustment_set_value (self->priv->tempo_adj, resetVal);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, resetVal, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void __lambda17__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda17_ (_sender, self);
}


static void rb_pitch_plugin_construct_ui (RBPitchPlugin* self) {
	GObject* _tmp0_ = NULL;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_ = NULL;
	GObject* _tmp3_ = NULL;
	GObject* _tmp4_ = NULL;
	GObject* _tmp5_ = NULL;
	GObject* _tmp6_ = NULL;
	GObject* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_builder_get_object (self->priv->builder, "window-control");
	self->priv->pitch_ui_parent = GTK_WINDOW (_tmp0_);
	g_signal_connect_object ((GtkWidget*) self->priv->pitch_ui_parent, "delete-event", (GCallback) __lambda11__gtk_widget_delete_event, self, 0);
	_tmp1_ = gtk_builder_get_object (self->priv->builder, "adjustment-control-pitch");
	self->priv->pitch_adj = GTK_ADJUSTMENT (_tmp1_);
	_tmp2_ = gtk_builder_get_object (self->priv->builder, "adjustment-control-speed");
	self->priv->speed_adj = GTK_ADJUSTMENT (_tmp2_);
	_tmp3_ = gtk_builder_get_object (self->priv->builder, "adjustment-control-tempo");
	self->priv->tempo_adj = GTK_ADJUSTMENT (_tmp3_);
	_tmp4_ = gtk_builder_get_object (self->priv->builder, "button-reset-pitch");
	self->priv->reset_pitch = GTK_BUTTON (_tmp4_);
	_tmp5_ = gtk_builder_get_object (self->priv->builder, "button-reset-tempo");
	self->priv->reset_tempo = GTK_BUTTON (_tmp5_);
	_tmp6_ = gtk_builder_get_object (self->priv->builder, "button-reset-speed");
	self->priv->reset_speed = GTK_BUTTON (_tmp6_);
	_tmp7_ = gtk_builder_get_object (self->priv->builder, "spinbutton-control-pitch");
	self->priv->pitch_sb = GTK_SPIN_BUTTON (_tmp7_);
	_tmp8_ = gtk_builder_get_object (self->priv->builder, "spinbutton-control-speed");
	self->priv->speed_sb = GTK_SPIN_BUTTON (_tmp8_);
	_tmp9_ = gtk_builder_get_object (self->priv->builder, "spinbutton-control-tempo");
	self->priv->tempo_sb = GTK_SPIN_BUTTON (_tmp9_);
	g_signal_connect_object (self->priv->pitch_adj, "value-changed", (GCallback) __lambda12__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->speed_adj, "value-changed", (GCallback) __lambda13__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->tempo_adj, "value-changed", (GCallback) __lambda14__gtk_adjustment_value_changed, self, 0);
	g_signal_connect_object (self->priv->reset_pitch, "clicked", (GCallback) __lambda15__gtk_button_clicked, self, 0);
	g_signal_connect_object (self->priv->reset_speed, "clicked", (GCallback) __lambda16__gtk_button_clicked, self, 0);
	g_signal_connect_object (self->priv->reset_tempo, "clicked", (GCallback) __lambda17__gtk_button_clicked, self, 0);
	g_signal_connect (self->priv->pitch_sb, "output", (GCallback) _rb_pitch_plugin_semitone_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->speed_sb, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->tempo_sb, "output", (GCallback) _rb_pitch_plugin_percent_output_cb_gtk_spin_button_output, NULL);
	g_signal_connect (self->priv->pitch_sb, "input", (GCallback) _rb_pitch_plugin_semitone_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->speed_sb, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	g_signal_connect (self->priv->tempo_sb, "input", (GCallback) _rb_pitch_plugin_percent_input_cb_gtk_spin_button_input, NULL);
	rb_pitch_plugin_download_controls (self);
}


gboolean rb_pitch_plugin_pitch_adj_timeout_cb (RBPitchPlugin* self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble val;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_adjustment_get_value (self->priv->pitch_adj);
	val = _tmp0_;
	_tmp1_ = rb_pitch_plugin_xlate_pitch_to_native (val);
	rb_pitch_plugin_set_dpitch (self, _tmp1_);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_CTRL_KEY, val, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	self->priv->pitch_adj_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


gboolean rb_pitch_plugin_speed_adj_timeout_cb (RBPitchPlugin* self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble val;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_adjustment_get_value (self->priv->speed_adj);
	val = _tmp0_;
	_tmp1_ = rb_pitch_plugin_xlate_ts_to_native (val);
	rb_pitch_plugin_set_drate (self, _tmp1_);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_CTRL_KEY, val, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	self->priv->speed_adj_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


gboolean rb_pitch_plugin_tempo_adj_timeout_cb (RBPitchPlugin* self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble val;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_adjustment_get_value (self->priv->tempo_adj);
	val = _tmp0_;
	_tmp1_ = rb_pitch_plugin_xlate_ts_to_native (val);
	rb_pitch_plugin_set_dtempo (self, _tmp1_);
	if (self->priv->persist) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, val, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	self->priv->tempo_adj_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


static gint rb_pitch_plugin_generic_input_cb (GtkSpinButton* t, void* new_value, GRegex* reg) {
	gint result = 0;
	gboolean success;
	gdouble* newval;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* btn_txt;
	gdouble from_spinbutton;
	GMatchInfo* mi = NULL;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* number;
	g_return_val_if_fail (t != NULL, 0);
	g_return_val_if_fail (reg != NULL, 0);
	success = FALSE;
	newval = (gdouble*) new_value;
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) t);
	_tmp1_ = g_strdup (_tmp0_);
	btn_txt = _tmp1_;
	from_spinbutton = 0.0;
	_tmp3_ = g_regex_match (reg, btn_txt, 0, &_tmp2_);
	_g_match_info_free0 (mi);
	mi = _tmp2_;
	success = _tmp3_;
	_tmp4_ = g_match_info_fetch_named (mi, "whole");
	number = _tmp4_;
	if (number == NULL) {
		success = FALSE;
	} else {
		gdouble _tmp5_;
		_tmp5_ = g_ascii_strtod (number, NULL);
		from_spinbutton = _tmp5_;
	}
	if (success) {
		*newval = from_spinbutton;
		result = (gint) TRUE;
		_g_free0 (number);
		_g_match_info_free0 (mi);
		_g_free0 (btn_txt);
		return result;
	} else {
		result = GTK_INPUT_ERROR;
		_g_free0 (number);
		_g_match_info_free0 (mi);
		_g_free0 (btn_txt);
		return result;
	}
	_g_free0 (number);
	_g_match_info_free0 (mi);
	_g_free0 (btn_txt);
}


gint rb_pitch_plugin_semitone_input_cb (GtkSpinButton* t, void* new_value) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (t != NULL, 0);
	_tmp0_ = rb_pitch_plugin_generic_input_cb (t, new_value, rb_pitch_plugin_semitone_input_regex);
	result = _tmp0_;
	return result;
}


gint rb_pitch_plugin_percent_input_cb (GtkSpinButton* t, void* new_value) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (t != NULL, 0);
	_tmp0_ = rb_pitch_plugin_generic_input_cb (t, new_value, rb_pitch_plugin_percent_input_regex);
	result = _tmp0_;
	return result;
}


gboolean rb_pitch_plugin_semitone_output_cb (GtkSpinButton* t) {
	gboolean result = FALSE;
	GtkAdjustment* _tmp0_ = NULL;
	gdouble _tmp1_;
	gdouble doub;
	gchar* _tmp2_;
	gchar* s;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	g_return_val_if_fail (t != NULL, FALSE);
	_tmp0_ = gtk_spin_button_get_adjustment (t);
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	doub = _tmp1_;
	_tmp2_ = g_strdup ("%.2f st");
	s = _tmp2_;
	_tmp3_ = g_strdup_printf (s, doub);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp4_);
	_tmp5_ = g_strdup_printf (s, doub);
	_tmp6_ = _tmp5_;
	gtk_entry_set_text ((GtkEntry*) t, _tmp6_);
	_g_free0 (_tmp6_);
	result = TRUE;
	_g_free0 (s);
	return result;
}


gboolean rb_pitch_plugin_percent_output_cb (GtkSpinButton* t) {
	gboolean result = FALSE;
	GtkAdjustment* _tmp0_ = NULL;
	gdouble _tmp1_;
	gdouble doub;
	gchar* _tmp2_;
	gchar* s;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	g_return_val_if_fail (t != NULL, FALSE);
	_tmp0_ = gtk_spin_button_get_adjustment (t);
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
	doub = _tmp1_;
	_tmp2_ = g_strdup ("%.1f%%");
	s = _tmp2_;
	_tmp3_ = g_strdup_printf (s, doub);
	_tmp4_ = _tmp3_;
	gtk_entry_set_text ((GtkEntry*) t, _tmp4_);
	_g_free0 (_tmp4_);
	result = TRUE;
	_g_free0 (s);
	return result;
}


static void rb_pitch_plugin_download_controls (RBPitchPlugin* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->persist) {
		gdouble _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_CTRL_KEY, &_inner_error_);
		_tmp1_ = _tmp0_;
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		gtk_adjustment_set_value (self->priv->pitch_adj, _tmp1_);
		_tmp2_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_CTRL_KEY, &_inner_error_);
		_tmp3_ = _tmp2_;
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		gtk_adjustment_set_value (self->priv->speed_adj, _tmp3_);
		_tmp4_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		gtk_adjustment_set_value (self->priv->tempo_adj, _tmp5_);
	}
}


static void rb_pitch_plugin_destroy_ui (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->pitch_ui_parent != NULL) {
		gtk_object_destroy ((GtkObject*) self->priv->pitch_ui_parent);
		self->priv->pitch_ui_parent = NULL;
	}
}


static void rb_pitch_plugin_destroy_config_ui (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->config_ui_parent != NULL) {
		gtk_object_destroy ((GtkObject*) self->priv->config_ui_parent);
		self->priv->config_ui_parent = NULL;
	}
}


static void rb_pitch_plugin_display_ui (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->pitch_ui_parent != NULL) {
		gtk_window_present (self->priv->pitch_ui_parent);
	}
}


static void rb_pitch_plugin_hide_ui (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_hide ((GtkWidget*) self->priv->pitch_ui_parent);
}


static void rb_pitch_plugin_hide_config_ui (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_hide ((GtkWidget*) self->priv->config_ui_parent);
}


static void rb_pitch_plugin_insert_pitch_element (RBPitchPlugin* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	if (!rb_pitch_plugin_inserted) {
		gboolean _tmp2_;
		_tmp2_ = rb_pitch_plugin_pitch_init_check (self, TRUE);
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = self->priv->sh != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		RBShellPlayer* _tmp3_ = NULL;
		RBShellPlayer* _tmp4_;
		RBShellPlayer* _tmp5_;
		RBShellPlayer* obj;
		_tmp3_ = rb_shell_get_player (self->priv->sh);
		_tmp5_ = _g_object_ref0 ((_tmp4_ = _tmp3_, RB_IS_SHELL_PLAYER (_tmp4_) ? ((RBShellPlayer*) _tmp4_) : NULL));
		obj = _tmp5_;
		if (obj != NULL) {
			RBPlayerGstFilter* _tmp6_ = NULL;
			RBPlayerGstFilter* filt;
			_tmp6_ = rb_pitch_plugin_get_filter (self);
			filt = _tmp6_;
			if (filt != NULL) {
				rb_player_gst_filter_add_filter (filt, self->priv->pitch_element);
				rb_pitch_plugin_inserted = TRUE;
			}
		} else {
			g_critical ("rbpitch-plugin.vala:618: ShellPlayer was NULL\n");
		}
		_g_object_unref0 (obj);
	} else {
		g_critical ("rbpitch-plugin.vala:622: inserted || !pitch_init_check() || sh == NULL" \
"\n");
	}
}


static void rb_pitch_plugin_remove_pitch_element (RBPitchPlugin* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	if (rb_pitch_plugin_inserted) {
		_tmp1_ = self->priv->pitch_element != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = self->priv->sh != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		RBShellPlayer* _tmp2_ = NULL;
		RBShellPlayer* _tmp3_;
		RBShellPlayer* _tmp4_;
		RBShellPlayer* obj;
		_tmp2_ = rb_shell_get_player (self->priv->sh);
		_tmp4_ = _g_object_ref0 ((_tmp3_ = _tmp2_, RB_IS_SHELL_PLAYER (_tmp3_) ? ((RBShellPlayer*) _tmp3_) : NULL));
		obj = _tmp4_;
		if (obj != NULL) {
			RBPlayerGstFilter* _tmp5_ = NULL;
			RBPlayerGstFilter* filt;
			_tmp5_ = rb_pitch_plugin_get_filter (self);
			filt = _tmp5_;
			if (filt != NULL) {
				rb_player_gst_filter_remove_filter (filt, self->priv->pitch_element);
				rb_pitch_plugin_inserted = FALSE;
			}
		} else {
			g_critical ("rbpitch-plugin.vala:639: ShellPlayer was NULL\n");
		}
		_g_object_unref0 (obj);
	} else {
		g_critical ("rbpitch-plugin.vala:643: !inserted || pitch_element == NULL || sh == N" \
"ULL\n");
	}
}


static RBPlayerGstFilter* rb_pitch_plugin_get_filter (RBPitchPlugin* self) {
	RBPlayerGstFilter* result = NULL;
	RBShellPlayer* _tmp0_ = NULL;
	RBShellPlayer* _tmp1_;
	RBShellPlayer* obj;
	GObject* v;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->sh == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = rb_shell_get_player (self->priv->sh);
	obj = (_tmp1_ = _tmp0_, RB_IS_SHELL_PLAYER (_tmp1_) ? ((RBShellPlayer*) _tmp1_) : NULL);
	if (obj == NULL) {
		result = NULL;
		return result;
	}
	v = NULL;
	g_object_get ((GObject*) obj, "player", &v, NULL);
	if (RB_IS_PLAYER_GST_FILTER (v)) {
		result = RB_PLAYER_GST_FILTER (v);
		return result;
	} else {
		g_critical ("rbpitch-plugin.vala:663: RBPlayer does not implement PlayerGstFilter i" \
"nterface\n");
		result = NULL;
		return result;
	}
}


static RBPlayer* rb_pitch_plugin_get_player_backend (RBPitchPlugin* self) {
	RBPlayer* result = NULL;
	RBShellPlayer* _tmp0_ = NULL;
	RBShellPlayer* _tmp1_;
	RBShellPlayer* _tmp2_;
	RBShellPlayer* obj;
	GObject* v;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = rb_shell_get_player (self->priv->sh);
	_tmp2_ = _g_object_ref0 ((_tmp1_ = _tmp0_, RB_IS_SHELL_PLAYER (_tmp1_) ? ((RBShellPlayer*) _tmp1_) : NULL));
	obj = _tmp2_;
	if (obj == NULL) {
		result = NULL;
		_g_object_unref0 (obj);
		return result;
	}
	v = NULL;
	g_object_get ((GObject*) obj, "player", &v, NULL);
	if (RB_IS_PLAYER (v)) {
		result = RB_PLAYER (v);
		_g_object_unref0 (obj);
		return result;
	} else {
		g_critical ("rbpitch-plugin.vala:681: RBShellPlayer's player property is not an RBP" \
"layer!\n");
		result = NULL;
		_g_object_unref0 (obj);
		return result;
	}
	_g_object_unref0 (obj);
}


gboolean rb_pitch_plugin_have_gst_player (RBPitchPlugin* self) {
	gboolean result = FALSE;
	RBPlayer* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = rb_pitch_plugin_get_player_backend (self);
	result = RB_IS_PLAYER_GST_FILTER (_tmp0_);
	return result;
}


gboolean rb_pitch_plugin_pitch_init_check (RBPitchPlugin* self, gboolean force) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (force) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->pitch_element != NULL;
	}
	if (_tmp0_) {
		GstElement* _tmp1_ = NULL;
		GstElement* _tmp2_;
		_tmp1_ = gst_element_factory_make ("pitch", NULL);
		_tmp2_ = _tmp1_;
		_gst_object_unref0 (self->priv->pitch_element);
		self->priv->pitch_element = _tmp2_;
		if (self->priv->pitch_element != NULL) {
			gdouble _tmp3_;
			gdouble _tmp4_;
			gdouble _tmp5_;
			_tmp3_ = rb_pitch_plugin_get_drate (self);
			g_object_set ((GObject*) self->priv->pitch_element, "rate", _tmp3_, NULL);
			_tmp4_ = rb_pitch_plugin_get_dpitch (self);
			g_object_set ((GObject*) self->priv->pitch_element, "pitch", _tmp4_, NULL);
			_tmp5_ = rb_pitch_plugin_get_dtempo (self);
			g_object_set ((GObject*) self->priv->pitch_element, "tempo", _tmp5_, NULL);
		}
	}
	result = self->priv->pitch_element != NULL;
	return result;
}


static void _lambda1_ (GConfClient* t, guint cnxn_id, GConfEntry* entry, RBPitchPlugin* self) {
	const gchar* _tmp0_ = NULL;
	const gchar* k;
	GConfValue* _tmp1_ = NULL;
	GConfValue* v;
	GConfValueType vt;
	g_return_if_fail (t != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = gconf_entry_get_key (entry);
	k = _tmp0_;
	_tmp1_ = gconf_entry_get_value (entry);
	v = _tmp1_;
	vt = v->type;
	if (vt == GCONF_VALUE_FLOAT) {
		gdouble _tmp2_;
		gdouble f;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		_tmp2_ = gconf_value_get_float (v);
		f = _tmp2_;
		if (g_strcmp0 (k, rb_pitch_plugin_GC_PITCH_UB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_UB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_PITCH_LB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_LB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_SPEED_UB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_UB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_SPEED_LB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_LB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_TEMPO_UB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_UB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_TEMPO_LB_KEY) == 0) {
			rb_pitch_plugin_try_adjust_bound (self, f, RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_LB);
			return;
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_PITCH_CTRL_KEY) == 0) {
			_tmp3_ = self->priv->persist;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gtk_adjustment_set_value (self->priv->pitch_adj, f);
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_SPEED_CTRL_KEY) == 0) {
			_tmp4_ = self->priv->persist;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			gtk_adjustment_set_value (self->priv->speed_adj, f);
		}
		if (g_strcmp0 (k, rb_pitch_plugin_GC_TEMPO_CTRL_KEY) == 0) {
			_tmp5_ = self->priv->persist;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			gtk_adjustment_set_value (self->priv->tempo_adj, f);
		}
	}
	if (vt == GCONF_VALUE_BOOL) {
		gboolean _tmp6_;
		gboolean b;
		_tmp6_ = gconf_value_get_bool (v);
		b = _tmp6_;
		if (g_strcmp0 (k, rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY) == 0) {
			self->priv->persist = b;
		}
	}
}


static void __lambda1__gconf_client_notify_func (GConfClient* client, guint cnxn_id, GConfEntry* entry, gpointer self) {
	_lambda1_ (client, cnxn_id, entry, self);
}


gboolean rb_pitch_plugin_gconf_init (RBPitchPlugin* self) {
	gboolean result = FALSE;
	GConfClient* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gconf_client_get_default ();
	self->priv->gconf = _tmp0_;
	if (self->priv->gconf == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gconf_client_dir_exists (self->priv->gconf, rb_pitch_plugin_GC_RBPITCH_DIR, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	if (!_tmp2_) {
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_UB_KEY, rb_pitch_plugin_PITCH_UB_MAX, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_LB_KEY, rb_pitch_plugin_PITCH_LB_MIN, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_UB_KEY, rb_pitch_plugin_SPEED_UB_MAX, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_LB_KEY, rb_pitch_plugin_SPEED_LB_MIN, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_UB_KEY, rb_pitch_plugin_TEMPO_UB_MAX, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_LB_KEY, rb_pitch_plugin_TEMPO_LB_MIN, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_CTRL_KEY, rb_pitch_plugin_PITCH_RESET, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_CTRL_KEY, rb_pitch_plugin_SPEED_RESET, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, rb_pitch_plugin_TEMPO_RESET, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		gconf_client_set_bool (self->priv->gconf, rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY, TRUE, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	gconf_client_add_dir (self->priv->gconf, rb_pitch_plugin_GC_RBPITCH_DIR, GCONF_CLIENT_PRELOAD_ONELEVEL, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	gconf_client_notify_add (self->priv->gconf, rb_pitch_plugin_GC_RBPITCH_DIR, __lambda1__gconf_client_notify_func, g_object_ref (self), g_object_unref, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp3_ = gconf_client_get_bool (self->priv->gconf, rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	self->priv->persist = _tmp4_;
	result = TRUE;
	return result;
}


static gdouble rb_pitch_plugin_get_pitch_lb (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_LB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gdouble rb_pitch_plugin_get_pitch_ub (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_UB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gdouble rb_pitch_plugin_get_speed_lb (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_LB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gdouble rb_pitch_plugin_get_speed_ub (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_UB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gdouble rb_pitch_plugin_get_tempo_lb (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_LB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gdouble rb_pitch_plugin_get_tempo_ub (RBPitchPlugin* self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_UB_KEY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
	result = _tmp1_;
	return result;
}


static gboolean rb_pitch_plugin_try_adjust_bound (RBPitchPlugin* self, gdouble val, RBPitchPluginBoundType bt) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	switch (bt) {
		case RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_UB:
		{
			gdouble _tmp0_;
			gdouble _tmp1_;
			gboolean _tmp2_;
			_tmp0_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_LB_KEY, &_inner_error_);
			_tmp1_ = _tmp0_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp2_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, _tmp1_, rb_pitch_plugin_PITCH_UB_MAX, rb_pitch_plugin_GC_PITCH_UB_KEY, rb_pitch_plugin_GC_PITCH_CTRL_KEY, self->priv->adj_config_pitch_ub, self->priv->pitch_adj, TRUE);
			result = _tmp2_;
			return result;
		}
		case RB_PITCH_PLUGIN_BOUND_TYPE_PITCH_LB:
		{
			gdouble _tmp3_;
			gdouble _tmp4_;
			gboolean _tmp5_;
			_tmp3_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_PITCH_UB_KEY, &_inner_error_);
			_tmp4_ = _tmp3_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp5_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, rb_pitch_plugin_PITCH_LB_MIN, _tmp4_, rb_pitch_plugin_GC_PITCH_LB_KEY, rb_pitch_plugin_GC_PITCH_CTRL_KEY, self->priv->adj_config_pitch_lb, self->priv->pitch_adj, FALSE);
			result = _tmp5_;
			return result;
		}
		case RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_UB:
		{
			gdouble _tmp6_;
			gdouble _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_LB_KEY, &_inner_error_);
			_tmp7_ = _tmp6_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp8_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, _tmp7_, rb_pitch_plugin_SPEED_UB_MAX, rb_pitch_plugin_GC_SPEED_UB_KEY, rb_pitch_plugin_GC_SPEED_CTRL_KEY, self->priv->adj_config_speed_ub, self->priv->speed_adj, TRUE);
			result = _tmp8_;
			return result;
		}
		case RB_PITCH_PLUGIN_BOUND_TYPE_SPEED_LB:
		{
			gdouble _tmp9_;
			gdouble _tmp10_;
			gboolean _tmp11_;
			_tmp9_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_SPEED_UB_KEY, &_inner_error_);
			_tmp10_ = _tmp9_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp11_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, rb_pitch_plugin_SPEED_LB_MIN, _tmp10_, rb_pitch_plugin_GC_SPEED_LB_KEY, rb_pitch_plugin_GC_SPEED_CTRL_KEY, self->priv->adj_config_speed_lb, self->priv->speed_adj, FALSE);
			result = _tmp11_;
			return result;
		}
		case RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_UB:
		{
			gdouble _tmp12_;
			gdouble _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_LB_KEY, &_inner_error_);
			_tmp13_ = _tmp12_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp14_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, _tmp13_, rb_pitch_plugin_TEMPO_UB_MAX, rb_pitch_plugin_GC_TEMPO_UB_KEY, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, self->priv->adj_config_tempo_ub, self->priv->tempo_adj, TRUE);
			result = _tmp14_;
			return result;
		}
		case RB_PITCH_PLUGIN_BOUND_TYPE_TEMPO_LB:
		{
			gdouble _tmp15_;
			gdouble _tmp16_;
			gboolean _tmp17_;
			_tmp15_ = gconf_client_get_float (self->priv->gconf, rb_pitch_plugin_GC_TEMPO_UB_KEY, &_inner_error_);
			_tmp16_ = _tmp15_;
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_tmp17_ = rb_pitch_plugin_try_adjust_bound_priv (self, val, rb_pitch_plugin_TEMPO_LB_MIN, _tmp16_, rb_pitch_plugin_GC_TEMPO_LB_KEY, rb_pitch_plugin_GC_TEMPO_CTRL_KEY, self->priv->adj_config_tempo_lb, self->priv->tempo_adj, FALSE);
			result = _tmp17_;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}


static gboolean rb_pitch_plugin_try_adjust_bound_priv (RBPitchPlugin* self, gdouble newval, gdouble oldlow, gdouble oldhigh, const gchar* config_key, const gchar* ctrl_key, GtkAdjustment* config_adj, GtkAdjustment* control_adj, gboolean isUpper) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (config_key != NULL, FALSE);
	g_return_val_if_fail (ctrl_key != NULL, FALSE);
	g_return_val_if_fail (config_adj != NULL, FALSE);
	g_return_val_if_fail (control_adj != NULL, FALSE);
	_tmp0_ = rb_pitch_plugin_clamp (&newval, oldlow, oldhigh);
	if (_tmp0_) {
		gconf_client_set_float (self->priv->gconf, config_key, newval, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = FALSE;
		return result;
	} else {
		gdouble _tmp1_;
		gdouble ctrl_val;
		gtk_adjustment_set_value (config_adj, newval);
		_tmp1_ = gtk_adjustment_get_value (control_adj);
		ctrl_val = _tmp1_;
		if (isUpper) {
			rb_pitch_plugin_clamp (&ctrl_val, oldlow, newval);
			gtk_adjustment_set_upper (control_adj, newval);
		} else {
			rb_pitch_plugin_clamp (&ctrl_val, newval, oldhigh);
			gtk_adjustment_set_lower (control_adj, newval);
		}
		gtk_adjustment_set_value (control_adj, ctrl_val);
		if (self->priv->persist) {
			gconf_client_set_float (self->priv->gconf, ctrl_key, ctrl_val, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
		}
		result = TRUE;
		return result;
	}
}


static GtkWidget* rb_pitch_plugin_real_create_configure_dialog (RBPlugin* base) {
	RBPitchPlugin * self;
	GtkWidget* result = NULL;
	self = (RBPitchPlugin*) base;
	result = (GtkWidget*) self->priv->config_ui_parent;
	return result;
}


static void rb_pitch_plugin_pitch_not_found_error (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	rb_pitch_plugin_display_error (self, "The pitch plugin was not found.\nPlease install GStreamer" "-plugins-bad-0.10 with SoundTouch support.\n" \
"Unload the Pitch and Tempo Shifting plugin to stop" " this message from appearing.");
}


static void rb_pitch_plugin_no_gst_error (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	rb_pitch_plugin_display_error (self, "Pitch and Tempo Shifting can not be used with your configuration." "\n" \
"Please use the GStreamer-0.10 backend.\n" \
"Unload the Pitch and Tempo Shifting plugin to stop" " this message from appearing.");
}


static void rb_pitch_plugin_no_gconf_error (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	rb_pitch_plugin_display_error (self, "Pitch and Tempo Shifting can not be used without GConf.\n" \
"Unload the Pitch and Tempo Shifting plugin to stop" " this message from appearing.");
}


static void rb_pitch_plugin_no_ui_file_error (RBPitchPlugin* self) {
	g_return_if_fail (self != NULL);
	rb_pitch_plugin_display_error (self, "The Pitch plugin can not find its UI file.\nPlease check " "your configuration.\n" \
"Unload the Pitch and Tempo Shifting plugin to stop" " this message from appearing.");
}


static void rb_pitch_plugin_display_error (RBPitchPlugin* self, const gchar* msg) {
	GtkMessageDialog* _tmp0_ = NULL;
	GtkMessageDialog* dialog;
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, msg);
	dialog = g_object_ref_sink (_tmp0_);
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_object_destroy ((GtkObject*) dialog);
	_g_object_unref0 (dialog);
}


static inline gdouble rb_pitch_plugin_xlate_pitch_to_semi (gdouble pitch_native) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	rb_pitch_plugin_clamp (&pitch_native, 0.1, 10.0);
	_tmp0_ = log (pitch_native);
	result = rb_pitch_plugin_CONST_S_X * _tmp0_;
	return result;
}


static inline gdouble rb_pitch_plugin_xlate_pitch_to_native (gdouble pitch_semi) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	_tmp0_ = rb_pitch_plugin_xlate_pitch_to_semi (0.1);
	_tmp1_ = rb_pitch_plugin_xlate_pitch_to_semi (10.0);
	rb_pitch_plugin_clamp (&pitch_semi, _tmp0_, _tmp1_);
	_tmp2_ = exp (pitch_semi * rb_pitch_plugin_CONST_G_X);
	result = _tmp2_;
	return result;
}


static inline gdouble rb_pitch_plugin_xlate_ts_to_semi (gdouble ts_native) {
	gdouble result = 0.0;
	rb_pitch_plugin_clamp (&ts_native, 0.1, 10.0);
	result = 100.0 * (ts_native - 1.0);
	return result;
}


static inline gdouble rb_pitch_plugin_xlate_ts_to_native (gdouble ts_semi) {
	gdouble result = 0.0;
	rb_pitch_plugin_clamp (&ts_semi, -90.0, 900.0);
	result = 1.0 + (ts_semi / 100.0);
	return result;
}


static gboolean rb_pitch_plugin_clamp (gdouble* test, gdouble low, gdouble high) {
	gboolean result = FALSE;
	if ((*test) < low) {
		*test = low;
		result = TRUE;
		return result;
	} else {
		if ((*test) > high) {
			*test = high;
			result = TRUE;
			return result;
		}
	}
	result = FALSE;
	return result;
}


gdouble rb_pitch_plugin_get_drate (RBPitchPlugin* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_drate;
	return result;
}


void rb_pitch_plugin_set_drate (RBPitchPlugin* self, gdouble value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value < 0.1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value > 10.0;
	}
	if (_tmp0_) {
		g_critical ("rbpitch-plugin.vala:164: drate value out of bounds: %f\n", value);
		return;
	}
	self->priv->_drate = value;
	if (self->priv->pitch_element != NULL) {
		g_object_set ((GObject*) self->priv->pitch_element, "rate", self->priv->_drate, NULL);
	}
	g_object_notify ((GObject *) self, "drate");
}


gdouble rb_pitch_plugin_get_dpitch (RBPitchPlugin* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_dpitch;
	return result;
}


void rb_pitch_plugin_set_dpitch (RBPitchPlugin* self, gdouble value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value < 0.1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value > 10.0;
	}
	if (_tmp0_) {
		g_critical ("rbpitch-plugin.vala:183: dpitch value out of bounds: %f\n", value);
		return;
	}
	self->priv->_dpitch = value;
	if (self->priv->pitch_element != NULL) {
		g_object_set ((GObject*) self->priv->pitch_element, "pitch", self->priv->_dpitch, NULL);
	}
	g_object_notify ((GObject *) self, "dpitch");
}


gdouble rb_pitch_plugin_get_dtempo (RBPitchPlugin* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_dtempo;
	return result;
}


void rb_pitch_plugin_set_dtempo (RBPitchPlugin* self, gdouble value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value < 0.1) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value > 10.0;
	}
	if (_tmp0_) {
		g_critical ("rbpitch-plugin.vala:202: dtempo value out of bounds: %f\n", value);
		return;
	}
	self->priv->_dtempo = value;
	if (self->priv->pitch_element != NULL) {
		g_object_set ((GObject*) self->priv->pitch_element, "tempo", self->priv->_dtempo, NULL);
	}
	g_object_notify ((GObject *) self, "dtempo");
}


static void rb_pitch_plugin_class_init (RBPitchPluginClass * klass) {
	gdouble _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	rb_pitch_plugin_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RBPitchPluginPrivate));
	RB_PLUGIN_CLASS (klass)->activate = rb_pitch_plugin_real_activate;
	RB_PLUGIN_CLASS (klass)->deactivate = rb_pitch_plugin_real_deactivate;
	RB_PLUGIN_CLASS (klass)->create_configure_dialog = rb_pitch_plugin_real_create_configure_dialog;
	G_OBJECT_CLASS (klass)->get_property = _vala_rb_pitch_plugin_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_rb_pitch_plugin_set_property;
	G_OBJECT_CLASS (klass)->finalize = rb_pitch_plugin_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RB_PITCH_PLUGIN_DRATE, g_param_spec_double ("drate", "drate", "drate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RB_PITCH_PLUGIN_DPITCH, g_param_spec_double ("dpitch", "dpitch", "dpitch", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RB_PITCH_PLUGIN_DTEMPO, g_param_spec_double ("dtempo", "dtempo", "dtempo", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = log (2.0);
	rb_pitch_plugin_LN_2 = _tmp0_;
	rb_pitch_plugin_CONST_S_X = 12.0 / rb_pitch_plugin_LN_2;
	rb_pitch_plugin_CONST_G_X = rb_pitch_plugin_LN_2 / 12.0;
	_tmp1_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/persist-controls");
	rb_pitch_plugin_GC_PERSIST_CONTROLS_KEY = _tmp1_;
	_tmp2_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/pitch-control");
	rb_pitch_plugin_GC_PITCH_CTRL_KEY = _tmp2_;
	_tmp3_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/speed-control");
	rb_pitch_plugin_GC_SPEED_CTRL_KEY = _tmp3_;
	_tmp4_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/tempo-control");
	rb_pitch_plugin_GC_TEMPO_CTRL_KEY = _tmp4_;
	_tmp5_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/pitch-ubound");
	rb_pitch_plugin_GC_PITCH_UB_KEY = _tmp5_;
	_tmp6_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/pitch-lbound");
	rb_pitch_plugin_GC_PITCH_LB_KEY = _tmp6_;
	_tmp7_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/speed-ubound");
	rb_pitch_plugin_GC_SPEED_UB_KEY = _tmp7_;
	_tmp8_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/speed-lbound");
	rb_pitch_plugin_GC_SPEED_LB_KEY = _tmp8_;
	_tmp9_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/tempo-ubound");
	rb_pitch_plugin_GC_TEMPO_UB_KEY = _tmp9_;
	_tmp10_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch/tempo-lbound");
	rb_pitch_plugin_GC_TEMPO_LB_KEY = _tmp10_;
	_tmp11_ = g_strdup ("/apps/rhythmbox/plugins/rbpitch");
	rb_pitch_plugin_GC_RBPITCH_DIR = _tmp11_;
	_tmp12_ = rb_pitch_plugin_xlate_pitch_to_semi (0.1);
	rb_pitch_plugin_PITCH_LB_MIN = _tmp12_;
	_tmp13_ = rb_pitch_plugin_xlate_pitch_to_semi (10.0);
	rb_pitch_plugin_PITCH_UB_MAX = _tmp13_;
	rb_pitch_plugin_SPEED_LB_MIN = -90.0;
	rb_pitch_plugin_TEMPO_LB_MIN = -90.0;
}


static void rb_pitch_plugin_instance_init (RBPitchPlugin * self) {
	GtkToggleAction* _tmp0_ = NULL;
	GtkActionGroup* _tmp1_ = NULL;
	self->priv = RB_PITCH_PLUGIN_GET_PRIVATE (self);
	self->priv->mergeid = (guint) 0;
	self->priv->persist = TRUE;
	self->priv->pitch_adj_timeout_id = (guint) 0;
	self->priv->speed_adj_timeout_id = (guint) 0;
	self->priv->tempo_adj_timeout_id = (guint) 0;
	_tmp0_ = gtk_toggle_action_new ("PitchAction", NULL, "Pitch and Tempo Control", NULL);
	self->priv->pitch_action = _tmp0_;
	_tmp1_ = gtk_action_group_new ("PitchActionGroup");
	self->priv->action_group = _tmp1_;
	self->priv->rbpitch_icon = NULL;
	self->priv->pitch_ui_parent = NULL;
	self->priv->uifile = NULL;
	self->priv->iconfile = NULL;
	self->priv->config_ui_parent = NULL;
	self->priv->gconf = NULL;
	self->priv->_drate = (gdouble) 1.0f;
	self->priv->_dtempo = (gdouble) 1.0f;
	self->priv->_dpitch = (gdouble) 1.0f;
}


static void rb_pitch_plugin_finalize (GObject* obj) {
	RBPitchPlugin * self;
	self = RB_PITCH_PLUGIN (obj);
	_gst_object_unref0 (self->priv->pitch_element);
	_g_object_unref0 (self->priv->pitch_action);
	_g_object_unref0 (self->priv->action_group);
	_g_object_unref0 (self->priv->rbpitch_icon);
	_g_object_unref0 (self->priv->builder);
	_g_free0 (self->priv->uifile);
	_g_free0 (self->priv->iconfile);
	G_OBJECT_CLASS (rb_pitch_plugin_parent_class)->finalize (obj);
}


GType rb_pitch_plugin_get_type (void) {
	return rb_pitch_plugin_type_id;
}


GType rb_pitch_plugin_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (RBPitchPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rb_pitch_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RBPitchPlugin), 0, (GInstanceInitFunc) rb_pitch_plugin_instance_init, NULL };
	rb_pitch_plugin_type_id = g_type_module_register_type (module, RB_TYPE_PLUGIN, "RBPitchPlugin", &g_define_type_info, 0);
	return rb_pitch_plugin_type_id;
}


static void _vala_rb_pitch_plugin_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RBPitchPlugin * self;
	self = RB_PITCH_PLUGIN (object);
	switch (property_id) {
		case RB_PITCH_PLUGIN_DRATE:
		g_value_set_double (value, rb_pitch_plugin_get_drate (self));
		break;
		case RB_PITCH_PLUGIN_DPITCH:
		g_value_set_double (value, rb_pitch_plugin_get_dpitch (self));
		break;
		case RB_PITCH_PLUGIN_DTEMPO:
		g_value_set_double (value, rb_pitch_plugin_get_dtempo (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_rb_pitch_plugin_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RBPitchPlugin * self;
	self = RB_PITCH_PLUGIN (object);
	switch (property_id) {
		case RB_PITCH_PLUGIN_DRATE:
		rb_pitch_plugin_set_drate (self, g_value_get_double (value));
		break;
		case RB_PITCH_PLUGIN_DPITCH:
		rb_pitch_plugin_set_dpitch (self, g_value_get_double (value));
		break;
		case RB_PITCH_PLUGIN_DTEMPO:
		rb_pitch_plugin_set_dtempo (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GType register_rb_plugin (GTypeModule* module) {
	GType result = 0UL;
	g_return_val_if_fail (module != NULL, 0UL);
	rb_pitch_plugin_register_type (module);
	result = TYPE_RB_PITCH_PLUGIN;
	return result;
}



